5 # date -R is linux-only, POSIX equivalent is '+%a, %d %b %Y %T %z'
6 datefmt
='+%a, %d %b %Y %T %z'
8 # darcs fast-export | git fast-import with error handling
10 "$cfg_basedir"/bin
/darcs-fast-export
--export-marks=$
(pwd)/dfe-marks
--import-marks=$
(pwd)/dfe-marks
"$1" | \
11 git fast-import
--export-marks=$
(pwd)/gfi-marks
--import-marks=$
(pwd)/gfi-marks
12 [ ${PIPESTATUS[0]} = 0 -a ${PIPESTATUS[1]} = 0 ]
16 # bzr fast-export | git fast-import with error handling
18 bzr fast-export
--export-marks=$
(pwd)/dfe-marks
--import-marks=$
(pwd)/dfe-marks
"$1" | \
19 git fast-import
--export-marks=$
(pwd)/gfi-marks
--import-marks=$
(pwd)/gfi-marks
20 [ ${PIPESTATUS[0]} = 0 -a ${PIPESTATUS[1]} = 0 ]
24 trap 'if [ $? != 0 ]; then echo "update failed dir: $PWD" >&2; fi; rm -f "$bang_log"' EXIT
27 cd "$cfg_reporoot/$proj.git"
29 if check_interval lastrefresh
$cfg_min_mirror_interval; then
30 progress
"= [$proj] update skip (last at $(config_get lastrefresh))"
33 progress
"+ [$proj] update (`date`)"
39 url
="$(config_get baseurl)"
40 mail="$(config_get owner)"
42 bang git for-each-ref
--format '%(refname) %(objectname)' >.refs-before
45 svn
://* | svn
+http
://* | svn
+https
://*)
46 # update the git svn url to match baseurl
49 if [ "$svnurl" != "$(git config --get svn-remote.svn.url || :)" ]; then
50 bang config_set_raw svn-remote.svn.url
"$svnurl"
51 bang git config
-f svn
/.metadata svn-remote.svn.reposRoot
"$svnurl"
53 # remove any stale *.lock files greater than 1 hour old in case
54 # git-svn was killed on the last update because it took too long
55 find svn
-type f
-name '*.lock' -mmin +60 -print0 |
xargs -0 rm -f
56 GIT_DIR
=. bang git svn fetch
--quiet
57 # git svn does not preserve group permissions in the svn subdirectory
58 chmod -R ug
+rw
,o
+r svn
61 httpurl
="${url/darcs:\/\//http://}"
62 bang git_darcs_fetch
"$httpurl"
65 bzrurl
="${url#bzr://}"
66 bang git_bzr_fetch
"$bzrurl"
69 [ "$url" = "$(git config --get remote.origin.url || :)" ] || bang config_set_raw remote.origin.url
"$url"
70 GIT_SSL_NO_VERIFY
=1 bang git remote update
71 bang git remote prune origin
75 bang git update-server-info
76 bang config_set lastrefresh
"$(date "$datefmt")"
78 # Look at which refs changed and trigger ref-change for these
79 bang git for-each-ref
--format '%(refname) %(objectname)' >.refs-after
80 sockpath
="$cfg_chroot/etc/taskd.socket"
81 if [ -S "$sockpath" ] && ! cmp -s .refs-before .refs-after
; then
82 join -j 1 .refs-before .refs-after |
83 while read ref old new
; do
84 [ "$old" != "$new" ] ||
continue
85 echo "ref-change %$proj% $proj $old $new $ref" | nc.openbsd
-w 1 -U "$sockpath"
87 join -j 1 -v 1 .refs-before .refs-after |
88 while read ref old
; do
89 echo "ref-change %$proj% $proj $old 0000000000000000000000000000000000000000 $ref" | nc.openbsd
-w 1 -U "$sockpath"
91 join -j 1 -v 2 .refs-before .refs-after |
92 while read ref new
; do
93 echo "ref-change %$proj% $proj 0000000000000000000000000000000000000000 $new $ref" | nc.openbsd
-w 1 -U "$sockpath"
97 rm -f .refs-before .refs-after
99 if [ -e .banged
]; then
100 echo "$proj update succeeded - failure recovery" |
mail -s "[$cfg_name] $proj update succeeded" "$mail,$cfg_admin"
104 progress
"- [$proj] update (`date`)"